﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.Core;

namespace Demo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void mapView_Loaded(object sender, RoutedEventArgs e)
        {
            string TheRasterPath;

            ThinkGeo.Core.PointShape TheCenterPoint;
            ThinkGeo.Core.PointShape TheUpperLeftPoint;
            ThinkGeo.Core.PointShape TheLowerRightPoint;
            ThinkGeo.Core.RectangleShape TheCurrentExtent;

            map.MapUnit = GeographyUnit.Meter;
            //map.CurrentExtent = MaxExtents.SphericalMercator;


            var gProjectionConverterForRendering = new UnmanagedProjectionConverter(4326, 3857);
            gProjectionConverterForRendering.Open();


            //// This jp2 file aleady 3857 projection.
            //var jp2Layer = new GdalRasterLayer(System.AppDomain.CurrentDomain.BaseDirectory + "\\World.jp2");
            //var overLay = new LayerOverlay();
            //overLay.Layers.Add(jp2Layer);
            //map.Overlays.Add(overLay);


            //var ecwLayer = new EcwRasterLayer(System.AppDomain.CurrentDomain.BaseDirectory + "\\World.ecw");
            //ecwLayer.ImageSource.ProjectionConverter = gProjectionConverterForRendering;
            //var overLay = new LayerOverlay();
            //overLay.TileType = TileType.SingleTile;
            //overLay.Layers.Add(ecwLayer);
            //map.Overlays.Add(overLay);

            //var geotifLayer = new UnmanagedGeoTiffRasterLayer(System.AppDomain.CurrentDomain.BaseDirectory + "\\World.tif");
            //geotifLayer.ImageSource.ProjectionConverter = gProjectionConverterForRendering;
            //var overLay = new LayerOverlay();
            //overLay.TileType = TileType.SingleTile;
            //overLay.Layers.Add(geotifLayer);
            //map.Overlays.Add(overLay);

            TheRasterPath = string.Format("{0}\\{1}", System.AppDomain.CurrentDomain.BaseDirectory, "World.sid");
            TheRasterPath = string.Format("{0}\\{1}", "C:\\OriStar\\Chicago\\OriStarVisionMapSuite\\MapRasters2008", "14LakeView2008.sid");

            var MrSidLayer = new MrSidRasterLayer(TheRasterPath);
            //MrSidLayer.ImageSource.ProjectionConverter = gProjectionConverterForRendering;

            var overLay = new LayerOverlay();
            overLay.TileBuffer = 0;
            overLay.TileWidth = 1920;
            overLay.TileHeight = 1200;
            overLay.TileType = TileType.SingleTile;

            overLay.Layers.Add(MrSidLayer);
            map.Overlays.Add(overLay);

            // set CurrentExtent based on all Layers
            map.CurrentExtent = overLay.GetBoundingBox();

            // get CenterPoint of BoundingBox
            TheCenterPoint = map.CurrentExtent.GetCenterPoint();

            // ZoomTo and Center
            map.ZoomTo(TheCenterPoint, map.ZoomLevelSet.ZoomLevel17.Scale);

            // Refresh to set MapView.CurrentExtent
            map.Refresh();

            // after Refresh need to get newly calculated CurrentExtent
            TheUpperLeftPoint = map.CurrentExtent.UpperLeftPoint;
            TheLowerRightPoint = map.CurrentExtent.LowerRightPoint;

            // set CurrentExtent based on CurrentExtent determined by above ZoomTo
            TheCurrentExtent = new RectangleShape(TheUpperLeftPoint, TheLowerRightPoint);
            map.CurrentExtent = TheCurrentExtent;

            // Refresh once again just for good-measure
            map.Refresh();
        }
    }
}
